#include <D:\8051\ARM\REG7S256.h>
#include <stdio.h>
#include <math.h>
		  
//   
extern void InitCE (void);
extern void PrintBuf(unsigned int POS);

char buf[80];							//  *read_line
char buffer [25];						//  sprintf
unsigned int Strob;						// 1
unsigned int Beep = 0;					//

int ADC_ch4;							//  4
//   5
int Summ5=0;							//  
int Start5=0;
int Samples5;							// 
int Freq5;								//  5
//   6
int Summ6=0;							//  
int Start6=0;
int Samples6;							// 
int Freq6;								//  6

extern char *read_line(char buf[]);		//    
extern void parseCmd( char *cmd );		//  
__irq void SYS_int(void);				// 
__irq void ADC_int(void);				//  
extern __irq void UART_RXTX_int(void);	//   / 
//--------------------------------------------------------------------------------------------------------------------
int main (void) {
	float F3;
//--------------------------------------------------------------------------------------------------------------------
// nRST .          ERSTL(8-11) 
//   RSTC_MR     0xA5    .  
//  . RSTC_MR(Reset Controller Mode Register). . 57 
//URSTEN(0)=1: User Reset Enable -     
//URSTIEN(4)=0:     
//BODIEN(16)=0:   Brownout Detection 
//ERSTL(8-11):        
//0xA5 -     
	*RSTC_MR  = 0xA5000001;
//--------------------------------------------------------------------------------------------------------------------
// Watchdog Timer. .83
// 12-,   SLCK/128.   16.   
//WDV(0-11) = FFF, .. .   WDRSTEN = 1,     
//   16. Watchdog Mode Register (WDT_MR)    
// . 
//WDFIEN(12) = 0 -  
//WDRPROC(14) = 0   . 1 -  . 
//WDDIS(15) = 0 -   .
//WDRSTEN = 1.  
//WDIDLEHLT(29) = 1. The Watchdog stops when the processor is in debug State5.
//WDDBGHLT(28) = 1. The Watchdog stops when the system is in idle State5.
//    WDD(16-27) = WDV(0-11) = FFF.  86
	*WDT_MR	=	0x3FFF2FFF;
//--------------------------------------------------------------------------------------------------------------------
//CKGR_MOR(Main Oscillator Register).  193
//  . 
//MOSCEN(0) = 01 -   MainCK.
//OSCBYPASS(1).  = 1,    XIN.
//OSCOUNT(8-15) =0xFF. Specifies the number of Slow Clock 
//cycles multiplied by 8 for the Main Oscillator Start5-up time.
	*CKGR_MOR	=	0x0000ff01; 	
//--------------------------------------------------------------------------------------------------------------------
//   - . .99.
// :
//NEBP(7)=0 No Erase Before Programming. =1 No erase is performed before programming.
//PROGE(3)=0 Programming Error Interrupt Enable. =1 Programming Error generates an interrupt.
//LOCKE(2)=0 Lock Error Interrupt Enable. =1 Lock Error generates an interrupt.
//FRDY(0)=0 Flash Ready Interrupt Enable. =1 Flash Ready generates an interrupt.
// 8-9 -  FWS -   (0-3)   .  0 
//    MCK   30. 
//  FMCN -   MCK   .    Flash
//   .
	*MC_FMR	=	0x00320100;	//FWS = 1 . 50   .
//--------------------------------------------------------------------------------------------------------------------
//Master Clock Controller MCK. .180.    (MCK)    
//Processor Clock Controller PCK.      ,
//(SLCK, MAINCK, PLLCK)   (1-64).
//CSS(0,1)(Clock Source Selection):
//CSS = 00 -  SCLK(32768)
//CSS = 01 -  MAINCK - 
//CSS = 11 -  PLL Clock ( )
//PRES(2,3,4).     2-64. 0 -  .  111  . 
//   0x18. SLCK,  64.   0x1 - MCK,  .
//PMC_MCKR: 0x0-SLCK, 0x4-SLCK/2, 0x8-SLCK/4, 0xc-SLCK/8, 0x10-SLCK/16, 0x14-SLCK/32, 0x18-SLCK/64=454.
//PMC_MCKR: 0x3-PLL, 0x7-PLL/2, 0xb-PLL/4, 0xf-PLL/8, 0x13-PLL/16, 0x17-PLL/32, 0x1b-PLL/64
//PMC_MCKR: 0x1-MCK, 0x5-MCK/2, 0x9-MCK/4, 0xd-MCK/8, 0x11-MCK/16, 0x15-MCK/32, 0x19-MCK/64	 196
	*PMC_MCKR	=	0x03;	//MCK=PLL.  .
//--------------------------------------------------------------------------------------------------------------------
// PLL.  177.   PLL     MAINCK.
//PLL    (1-255)  (1-2047).     
//MAINCK  (MUL + 1)/DIV. CKGR_PLLR(PMC Clock Generator PLL Register). . 195				   
	*CKGR_PLLR	=	0x00023f01;	 // = 3,  =1  48
//DIV(0-7). 00h - . 01h -  
//PLLCOUNT(8-13) = 3F -  .    SLCK   LOCK 
// PMC_SR   ,  CKGR_PLLR  .
//OUT(14,15) -    . . PLL Clock Frequency Range
//MUL(16-23,24,25,26) -  . 0 = PLL .
//  :  = 0xdf,  = 0x4ff
//18.32x((4ff+1)/0xdf)=18.432x(1280/223) = 105,8
//16.000 000 x((5f+1)/0x8B)=16.000 000 x (96/139) = 11 050 359
//18.432 000 x((96+1)/0xFA)=18.432 000 x (150/250) =11 059 200
//--------------------------------------------------------------------------------------------------------------------
// . PMC_PCER (Peripheral Clock Enable). .192.
	*PMC_PCER =	(1 << 2) |			//  PIO (   )
				(1 << 30)|			//   IRQ
				(1 << 12)|			//  16 -   0
				(1 << 13)|			//  16 -   1
				(1 << 10)|			//  PWM
				(1 << 6)|			//  USART 0
				(1 << 4);			//  
//--------------------------------------------------------------------------------------------------------------------
// USART.  293.
//US_CR(USART Control Register). 
//RSTRX(2): Reset Receiver
//RSTTX(3): Reset Transmitter
//RXEN(4): Receiver Enable
//RXDIS(5): Receiver Disable
//TXEN(6): Transmitter Enable
//TXDIS(7): Transmitter Disable
//RSTSTA(8): Reset Status Bits:PARE, FRAME, OVRE, RXBRK  US_CSR.
//STTBRK(9): Start5 Break. STPBRK(10): Stop Break. Start5s/Stop transmission of a break after 
//the characters present in US_THR and the Transmit Shift Register have been transmitted.
//No effect if a break is already being transmitted.
//STTTO(11): Start5 Time-out. 1: Start5s waiting for a character before clocking the time-out counter.
//SENDA(12): Send Address. In Multidrop Mode only
//RSTIT(13): Reset Iterations. 1 = Resets ITERATION in US_CSR.
//RSTNACK(14): Reset Non Acknowledge. 1 = Resets NACK in US_CSR.
//RETTO(15): Rearm Time-out. 1 = ReStart5 Time-out
//DTREN(16): Data Terminal Ready Enable. 1 =   DTR  0.
//DTRDIS(17): Data Terminal Ready Disable. 1 =   DTR  1.
//RTSEN(18): Request to Send Enable. 1 =   RTS  0.
//RTSDIS(19): Request to Send Disable. 1 =   RTS  1.
//US_MR (USART Mode Register).
//USART_MODE(0-3) (Normal(0), RS485(1), Hardware Handshaking(2), Modem(3), IS07816(4,6), IrDA(8) 
//USCLKS(4-5).  : MCK(0), MCK / DIV(1), SCK(3,  ).
//CHRL(6-7).  . 5bits(0), 6bits(1), 7bits(2), 8bits(3).
//SYNC(8). 1 = Synchronous Mode Select.  
//PAR(9-11). Even(0), Odd(1), Space(2), Mark(3), No parity(4), Multidrop mode(5)	
//NBSTOP(12-13).   . 1stop(0), 1.5stop(1), 2stop(2)
//CHMODE(14-15).  . Normal(0), Automatic Echo(1), Local Loopback(2), Remote Loopback(3)
//MSBF(16).	Bit Order. 0 = LSB first. 1 = MSB first.
//MODE9(17). 1 = 9-bit Character Length.
//CLKO(18). 1 = The USART drives the SCK pin if USCLKS does not select the external clock SCK.
//OVER(19). 0 = 16x Oversampling. 1 = 8x Oversampling.
//INACK(20). 0 = The NACK is generated. 1 = The NACK is not generated.
//DSNACK(21). Disable Successive NACK(ISO).
//VAR_SYNC(22). 0 = User defined configuration of command or data sync field depending on SYNC value.
//1 = The sync field is updated when a character is written into US_THR register.
//MAX_ITERATION(24-26). Defines the maximum number of iterations in mode ISO7816, protocol T= 0.
//FILTER(28). Infrared Receive Line Filter.
//MAN(29). Manchester Encoder/Decoder Enable
//ONEBIT(31). Start5 Frame Delimiter selector
//US_IER (USART Interrupt Enable Register)
//RXRDY(0): RXRDY Interrupt Enable
//TXRDY(1): TXRDY Interrupt Enable
//RXBRK(2): Receiver Break Interrupt Enable
//ENDRX(3): End of Receive Transfer Interrupt Enable
//ENDTX(4): End of Transmit Interrupt Enable
//OVRE(5): Overrun Error Interrupt Enable
//FRAME(6): Framing Error Interrupt Enable
//PARE(7): Parity Error Interrupt Enable
//TIMEOUT(8): Time-out Interrupt Enable
//TXEMPTY(9): TXEMPTY Interrupt Enable
//ITERATION(10): Iteration Interrupt Enable
//TXBUFE(11): Buffer Empty Interrupt Enable
//RXBUFF(12): Buffer Full Interrupt Enable
//NACK(13): Non Acknowledge Interrupt Enable
//RIIC(16): Ring Indicator Input Change Enable
//DSRIC(17): Data Set Ready Input Change Enable
//DCDIC(18): Data Carrier Detect Input Change Interrupt Enable
//CTSIC(19): Clear to Send Input Change Interrupt Enable
//US_RHR( ), US_THR( ).
//RXCHR(0-7) -  , TXCHR(0-7) -  . 
//RXCHR(8). Last character received if RXRDY is set. TXCHR(8) - Next character to be transmitted after the current character if TXRDY is not set.
//RXSYNH(15) - 0 = Last Character received is a Data. 1 = Last Character received is a Command.
//TXSYNH(15) - 0: The next character sent is encoded as a data. 1 = The next character sent is encoded as a command.
//US_BRGR(USART Baud Rate Generator Register)
//CD(0-15) -   . 
//FP(16-18) -   .
//US_RTOR(USART Receiver Time-out Register).
//TO(0-15). 1 - 65535: The Receiver Time-out is enabled and the Time-out delay is TO x Bit Period.
//US_TTGR(USART Transmitter Timeguard Register)
//TG(0-7)1 - 255: The Transmitter timeguard is enabled and the timeguard delay is TG x Bit Period.
//US_FIDI(FI Over DI Ratio Value)
//FI_DI_RATIO(0-10). 1 - 2047. ISO7816 mode
//US_MAN(USART Manchester Configuration Register)
//US_IF(USART IrDA FILTER Register)
//IRDA_FILTER(0-7). Sets the filter of the IrDA demodulator.
//     USCLKS   Master Clock(MCK), MCK/DIV,
//SCK( ).
//Baud Rate Generator   16- ,    CD(US_BRGR).
// CD=0  .  FP(US_BRGR)   .  FP = 0, 
// .  Baudrate = SelectedClock/(8(2 Over)(CD + FP/8))
	*PIO_PDR=	(1 <<  5) |			//Enable RxD0 Pin
				(1 <<  6);			//Enalbe TxD0 Pin
	*US_CR =	(0x1 <<  2)|		//Reset Receiver
				(0x1 <<  3)|		//Reset Transmitter
				(0x1 <<  5)|		//Receiver Disable
				(0x1 <<  7);		//Transmitter Disable
	*US_MR =	0x0 |				//Normal Mode
           	 	(0x0 <<  4)|		//Clock = MCK
           	 	(0x3 <<  6)|		//8-bit Data
             	(0x4 <<  9)|		//No Parity
           	 	(0x0 << 12);		//1 Stop Bit
	*US_BRGR =	26;					//  FP = 0 (  48 000 000 / 16 / 26 = 115385)
	*US_CR =	(0x1 <<  4)|		//Receiver Enable
             	(0x1 <<  6);		//Transmitter Enable
	*AIC_SVR6=	(unsigned long) UART_RXTX_int; //   USART0
	*AIC_SMR6= 	3|1<<5;				// 3,  (SRCTYPE=1)
	*AIC_IECR=	(1 << 6);			//   USART0 PID=6(35)
	*ADC_CHER=	(1<<4);
	*US_IER=1;						//    RXRDY = 1
//--------------------------------------------------------------------------------------------------------------------
//PMC_PCK(PMC Programmable Clock Register). . 181. PMC    ,
//PCK(1-3),    .       
//SCLK, MAINCK  PLL.        1-64(PRES).
//      1  PMC_SCER (PMC System Clock Enable Register)
//   1  PMC_SCDR(PMC System Clock Disable Register) 
//     PA21 . 
//CSS(0,1)(Clock Source Selection):
//CSS = 00 -  SCLK( 1000   MCK 18)
//CSS = 01 -  MAINCK - 
//CSS = 11 -  PLL Clock ( )
//PRES(2,3,4).     2-64. 0 -  .  111  . 
//000-=1, 001-=2, 010-=4, 011-=8, 100-=16, 101-=32, 110-=64. SLCK = 29.1
//PMC_PCK1: 0x0-SLCK, 0x4-SLCK/2, 0x8-SLCK/4, 0xc-SLCK/8, 0x10-SLCK/16, 0x14-SLCK/32, 0x18-SLCK/64=454.
//PMC_PCK1: 0x3-PLL, 0x7-PLL/2, 0xb-PLL/4, 0xf-PLL/8, 0x13-PLL/16, 0x17-PLL/32, 0x1b-PLL/64
//PMC_PCK1: 0x1-MAINCK, 0x5-MAINCK/2, 0x9-MAINCK/4, 0xd-MAINCK/8, 0x11-MAINCK/16, 0x15-MAINCK/32, 0x19-MAINCK/64
	*PMC_PCK1	=0x0000001B;		//0x13-PLL/64 PA21, P3.5
	*PMC_SCER	=0x00000200;		// PCK1 (9).
// : SLCK = 29.8, MCK = 16, PLL = 11.0
//--------------------------------------------------------------------------------------------------------------------
//PIO c. 225. 
//Pull-up       .  
// pull-ups   ..  PIO_PUSR = 0x0. Pull-up   
//PIO_PUER(Pull-up Enable Register) = 1   PIO_PUD(Pull-up Disable Resistor) = 1.
//      PIO_MDER =1 (Multi-driver Enable Register) 
//  push - pull PIO_MDDR = 1 (Multi-driver Disable Register).    
//push - pull.
// PIO_PER(PIO Enable Register) = 1,     PIO . 
// PIO_PDR(PIO Disable Register) = 1,        A  B. 
//     PIO .     ,
//      (PIO_ASR = 1  PIO_BSR = 1)      
// PIO PIO_PDR(PIO Disable Register) = 1.
//     PIO_OER(Output Enable Register) = 1.
//   PIO_ODR(Output Disable Register) = 1.
//    :  PIO_SODR(Set Output DataRegister) = 1,
// PIO_CODR(Clear Output Data Register) = 1.    . 
//        
//PIO_OWSR(Output Write Status Register) =1 .
//     PIO_PDSR(Pin Data Status Register). 
//    / .    
//  PIO!
// glitch    PIO_IFER(Input Filter Enable Register) = 1,
// PIO_IFDR(Input Filter Disable Register) = 1.     
//      MCK .     
//.
	*PIO_PDR	=(1<<21)|(1<<24);	//   PIO  PA21(PCK1)  PA24(PWM1) 
	*PIO_BSR	=(1<<21)|(1<<24);	//  B  PA21(PCK1)  PA24(PWM1)
	*PIO_PER	=0x7 				//  PIO   PA0-2
					 |(0x7F<<8)		// PA08 - PA14 -   
					 |(1<<18)		//   PA18 = P3.2
 					 |(1<<19)		//   PA18 = P3.3
 					 |(1<<20);		//   PA18 = P3.4
	*PIO_OER	=0x7 				//    PA0-2
					 |(1<<18)		//   PA18 = P3.2
					 |(1<<19)		//   PA18 = P3.3
 					 |(1<<20)		//   PA18 = P3.4
					 |(0x7F<<8);	// PA08 - PA14 -   
//--------------------------------------------------------------------------------------------------------------------
//  .   MCK/16. . 77
//20-bit  CPIV   0    PIV    .
//   12- PICNT(Periodic Interval Counter)    CPIV
// PIT_SR.    ,      PITIEN  PIT_MR.
//   CPIV  PICNT  PIT_PIVR(Periodic Interval Value Register)  PITS
//  PICNT . 
//   CPIV  PICNT  PIT_PIIR(Periodic Interval Image Register)  PITS
//  PICNT  .
//PITIEN(25) -    PIT. 
//PITEN(24) -   PIT. 
//PIV(0-19) -   PIT.
  *PIT_MR =	(1 << 25)|				//   PIT
			(1 << 24)|				//  PIT
			0xAFFFF;				//  PIT.   1 048 575(FFFFFh)(20 )
//--------------------------------------------------------------------------------------------------------------------
//. 151.
//  System Timer, the Real Time Clock, Power Management Controller and
//Memory Controller     1(SYS).   2  31
//    .     
//   PIO .
//  (7...0)   PRIOR  AIC_SMR (Source Mode Register)
//      ,   
//     PID.
//      nIRQ  . 
//       nIRQ,  
//     AIC_IVR (Interrupt Vector Register).  
//AIC_IVR       .  nIRQ  
//      .   
//    ,      
//        AIC_EOICR (End of Interrupt 
//Command Register).   AIC_EOICR     . 
// .         
//  ,  nIRQ  .    
//  ,        
//       AIC_IVR.     
//        .    
//          .
//AIC    8    .
//  ( )      
//AIC_SVR1 - AIC_SVR31(Source Vector Register 1 to 31).  AIC_IVR 
//(Interrupt Vector Register)   ,   AIC_SVR
//  .       
//     LDR PC,[PC,# -&F20],   
// 0x0000 0018.       0xFFFF F100,   
// AIC_IVR.
//     AIC_IVR (Interrupt Vector Register)
//  Fast Forcing feature      AIC_IVR!
//  0 (FIQ)    .  PRIOR  
//AIC_SMR0  .      AIC_SVR0 
//(Source Vector Register 0).     AIC_FVR (Fast Vector Register)
//  LDR PC,[PC,# -&F20],     0x0000 001C.
//      0xFFFF F104,     AIC_FVR.
//          
//Fast Forcing Enable Register (AIC_FFER) and the Fast Forcing Disable Register (AIC_FFDR). 
// AIC_FVR    .    Fast Forcing 
//    Interrupt Clear Command Register (AIC_ICCR).
//SRCTYPE(5,6) AIC_SMR0..AIC_SMR31) -   / 
//PRIOR(0,1,2)(AIC_SMR0..AIC_SMR31) - 8  .  7 -  .  
//AIC_IECR (Interrupt Enable Command Register)
//AIC_IDCR (Interrupt Disable Command Register)
//AIC_IPR (Interrupt Pending Register)
//AIC_ISCR -    . AIC_ICCR -  .
	*AIC_SMR1	=	(1 << 5) | 3;	//Positive edge triggered (5), 3-  
	*AIC_SVR1	=	(unsigned long) SYS_int; //   
	*AIC_IECR	=	(1 << 1);		//   SYS(1)
//--------------------------------------------------------------------------------------------------------------------
// . . 473.
//      ADC  ADC_CHER,    
// PIO. ADC    MCK/2,  PRESCAL=0  MCK/128,  PRESCAL=63 (0x3F)
//    ADC_CDR(0-7, Channel Data Register)   ADC_LCDR
//(Last Converted Data Register).      
//EOC  DRDY  ADC_SR(Status Register).  EOC    .
// DRDY -    .     .
// ADC_CDR  EOC .  ADC_LCDR  DRDY  EOC .
//ADC  Start5up Time,    SHTIM. Start5up Time 
//  . 
//ADC_MR: 
//TRGEN(0) = 0 -   . 
//TRGSEL(1-3) = 0 -   .
//LOWRES(4) = 0 - 8- . 
//SLEEP(5) = 0 - . 
//PRESCAL(8-13) - Prescaler Rate Selection. ADCClock = MCK / ( (PRESCAL+1) * 2 ).
//Start5UP(16-20) - Start5 Up Time = (Start5UP+1) * 8 / ADCClock. 
//SHTIM(24-27) - Sample & Hold Time =(SHTIM+1)/ADCClock
	*ADC_MR		=	(16<<24)|		//Sample & Hold Time = (SHTIM+1) / ADCClock  481
					(1<<16)|		//Start5up Time(16-20) = (StartUP+1) * 8 / ADCClock
					(63<<8);		//Prescaler Rate Selection ADCClock = MCK / ( (PRESCAL+1) * 2 )
	*ADC_CHER	=	(1<<4);			//  4- 
	*AIC_SMR4	=	(1 << 5) | 7;	//Positive edge triggered (5), 7-  
	*AIC_SVR4	=	(unsigned long) ADC_int; //   
	*AIC_IECR	=	(1 << 4);		//    PID=4(35)
	*ADC_IER	=	(1<<16);		//      DRDY
	*ADC_CR=(1<<1);
//--------------------------------------------------------------------------------------------------------------------
// 16-   . .385.
//  3   .    3  ,
//5   2  /.     .
//  2  . Block Control Register   3 .
//TC_BMR(Block Mode Register)      .
//             
//TCLK0, TCLK1, TCLK2    TIOA0, TIOA1, TIOA2.    
//  TIMER_CLOCK1(MCK/2), TIMER_CLOCK2(MCK/8), TIMER_CLOCK3(MCK/32), TIMER_CLOCK4(MCK/128), 
//TIMER_CLOCK5(MCK/1024).    TCCLKS bits  TC_CMR(TC Channel Mode
//Register). . 389.        CLKI  TC_CMR.
//      Capture  Waveform.  
// WAVE  TC_CMR.
    *TC0_CCR = 0x6; 				//  5.  .
	*TC0_CMR =1<<15|2; 				//WAVE:Waveform mode. TCCLKS: MCK/32
	*TC1_CCR = 0x6; 				//  6.  .
	*TC1_CMR =1<<15|2; 				//WAVE:Waveform mode. TCCLKS: MCK/32

//--------------------------------------------------------------------------------------------------------------------
//PWM. 16 - .  421.
//.   MCK   ,   MCK/2  
//MCK/1024.   (  PREA  PREB(PWM_MR))    .   
//     1-255(DIVA  DIVB(PWM_MR)).  ,      MCK/2  MCK/1024
//      PWM(0-4) -  CPRE   PWM_CMRx.
//PWM_MR(PWM Mode Register):
//DIVA(0-7), DIVB(16-23) -   CLKA  CLKB
//PREA(8-11), PREB(24-27) -       1-255. . 430.
//PWM_ENA(PWM Enable Register), PWM_DIS(PWM Disable Register):
//CHID3(3),CHID2(2),CHID1(1),CHID0(0) - /  .
//PWM_CMRx(PWM Channel Mode Register):
//CPRE(0-3) -     . 15(MCK - MCK/1024, CLKA, CLKB)
//CALG(8) - Channel Alignment. 1 = The period is center aligned. 0 = The period is left aligned.
//CPOL(9): Channel Polarity. 0 = The output waveform Start5s at a low level. 
//1 = The output waveform Start5s at a high level.
//CPD(10): Channel Update Period. 0 = Writing to the PWM_CUPDx will modify the duty cycle at the next period Start5 event.
//1 = Writing to the PWM_CUPDx will modify the period at the next period Start5 event.
//PWM_CPRDx(PWM Channel Period Register).  .   
//PWM , ..  .
//PWM_CDTYx(0-16, PWM Channel Duty Cycle Register).  .      
//   WM_CPRDx.  .
//PWM_CUPDx(PWM Channel Update Register).  .    
//.  /    CPD(PWM_CMRx).   .    
	*PWM_MR =  10<<8|1; 	// :DIVA = 1, PREA = 10(MCK/1024)
	*PWM_CMR1 = 0xb;		//  CLKA.
	*PWM_CPRD1 = 32;		//.    .  16.
	*PWM_CDTY1 = 16;		// 50% (PWM_CPRD1 / 2)
//--------------------------------------------------------------------------------------------------------------------
//Real-time Timer. . 71.   SLCK   16- 
//RTPRES(0-15)  RTT_MR. 32-      RTPRES=0x00008000.
// (32)  136.  RTPRES=3  .
// (32)     RTT_VR (Real-time Value Register).
//  (32)   RTT_AR (Real-time Alarm Register).  
// ALMS  RTT_SR.  RTT_AR    0xFFFF_FFFF.
//RTTINC  RTT_SR      (32)  
//    .  RTT_SR  RTTINC  ALMS.
// RTTRST = 1  RTT_MR        
//.   32- .
	*RTT_MR1=0x00008000 | (1<<17);	//    RTTINCIEN(17) = 1
//-------  
	Beep = 3;
	InitCE();
//--------------------------------------------------------------------------------------------------------------------
	for (;;) {										//
	double Volt;									//
	double AverVolt5;								//  5
	double AverVolt6;								//  6
	float Freq5fl;									//  5
	float Freq6fl;									//  6
	static int LED;									//
// . printf("\n%s\n", buf); - 
		if(read_line(buf))  						//read_line( buf )   buf  
			{parseCmd(buf);}						//    read_line( buf ) <> 0
//    
		if (Strob) {								//3.5  
			Strob = 0;								// 1
			*WDT_CR = 0xA5000001;					// Watchdog Timer 	
			if(LED) {*PIO_SODR = 5; *PIO_CODR = 2; LED = 0;}
			else {*PIO_CODR = 5; *PIO_SODR = 2; LED = 1;}
//   
			F3 = (float)((ADC_ch4*3.00)/1024);		//20
			printf ("U=%1.3f\t", F3);				//100
			sprintf (buffer, "U=%1.3f\n",F3);  		//80
			PrintBuf(0x80);            				//600
			if (Start5==4) { 						//  5  
				Volt = sqrt(Summ5/Samples5);		//40
				AverVolt5 = (AverVolt5*7)/8 + Volt/8;//30
			   	Freq5fl = (float)*TC0_CV/600;		//   
				printf ("U5=%1.1f\t%1.1f\t%i\t",AverVolt5,Freq5fl,Samples5);//130
				sprintf (buffer, "U5=%1.1f %1.1f %i\n",AverVolt5,Freq5fl,Samples5);//100
				PrintBuf(0x94);            			//1000
				Start5=0;							// 
		   		Summ5 = 0;							// 
				Samples5 =0;						//  
				*ADC_CHER=	(1<<4);					// -  
		 		*ADC_CR=(1<<1);}					// 
			if (Start6==4) { 						//  6  
				Volt = sqrt(Summ6/Samples6);		//40
				AverVolt6 = (AverVolt6*15)/16 + Volt/16;//30
			   	Freq6fl = (float)*TC1_CV/600;		//   
				printf ("U6=%1.1f\t%1.1f\t%i\n",Volt,Freq6fl,Samples6);//130
				sprintf (buffer, "U6=%1.1f %1.1f %i\n",Volt,Freq6fl,Samples6);//100
				PrintBuf(0xd4);            			//1000
				Start6=0;							// 
		   		Summ6 = 0;							// 
				Samples6 =0;						//  
				*ADC_CHER=	(1<<4);					// -  
		 		*ADC_CR=(1<<1);}					// 
		}											//if (Strob)
	}												//for (;;) 
}													//Main
//--------------------------------------------------------------------------------------------------------------------
__irq void SYS_int (void) {			//  System Controller.   1   48
	if (*PIT_SR & 0x1) {			//  PITS(0)  PIT_SR -    
		if (Beep) {					//  Periodic Interval Timer (PIT) 77.
			Beep--;					//
			*PWM_ENA = 2;}			//   PWM1 (CHID1)		
		else {*PWM_DIS = 2;} 		//   PWM1 (CHID1)
		*AIC_EOICR = *PIT_PIVR;	}	// PIT_PIVR   PITS  PIT_SR
	if (*RTT_SR1 & 0x2) {			//  450   48
		Strob = 1;					//  Real-time Timer (RTT) (  ) 71.
		*AIC_EOICR = 1;}			//
}//__irq void SYS_int (void)
//--------------------------------------------------------------------------------------------------------------------		
__irq void ADC_int(void) {			//    DRDY
	if (*ADC_SR & 16) {				//   EOC4
		ADC_ch4 = *ADC_CDR4;		//      EOC4
		*ADC_CHER =	32;}			//  5
	if (*ADC_SR & 32) {				//   EOC5.   2.7   48
		int signADC;				//    
		signADC = *ADC_CDR5-ADC_ch4;//      1.5			
// 
		if ((signADC <-10)&&(Start5==0)){Start5=1;}//  
		if ((signADC >10)&&(Start5==1)) {Start5=2; *TC0_CCR = 0x5;}//  
		if ((signADC <-10)&&(Start5==2)){Start5=3;}//  
		if ((signADC >10)&&(Start5==3)) {Start5=4; *TC0_CCR = 0x6;}//  
//    
		if ((Start5>1)&&(Start5<4)) {//        
			*PIO_SODR = (1<<18);	 // UP
			Summ5 = Summ5 + (signADC * signADC); Samples5++; }//      
		else {*PIO_CODR = (1<<18);}	// DOWN
		*ADC_CHER =	64;	}			//   6
	if (*ADC_SR & 64) {				//   EOC6
		int signADC;				//    
		signADC = *ADC_CDR6-ADC_ch4;//      1.5			
// 
		if ((signADC <-10)&&(Start6==0)){Start6=1;}//  
		if ((signADC >10)&&(Start6==1)) {Start6=2; *TC1_CCR = 0x5;}//  
		if ((signADC <-10)&&(Start6==2)){Start6=3;}//  
		if ((signADC >10)&&(Start6==3)) {Start6=4; *TC1_CCR = 0x6;}//  			
//    
		if ((Start6>1)&&(Start6<4)) {//        
			*PIO_SODR = (1<<19);	 // UP
			Summ6 = Summ6 + (signADC * signADC); Samples6++; }//      
		else {*PIO_CODR = (1<<19);}	 // DOWN
		*ADC_CHER =	32;}			//  5
// 
		*ADC_CR=(1<<1);				// 
		*AIC_EOICR = 1;}			//__irq void ADC_int(void)

