#include <D:\8051\ARM\REG7S256.h>
#include <stdio.h>
#include <string.h>
#define _ARMABI __declspec(__nothrow)
typedef struct __FILE FILE;
_ARMABI int printf(const char * __restrict /*format*/, ...) __attribute__((__nonnull__(1)));
struct __FILE { int handle;};
FILE __stdout;

extern unsigned int Beep;
//UART 
#define USART_TX_BUFFER_SIZE 16	 		//2,4,8,16,32,64,128 or 256 bytes
#define USART_TX_BUFFER_MASK (USART_TX_BUFFER_SIZE - 1)
char USART_TxBuf[USART_TX_BUFFER_SIZE];
volatile int USART_TxHead=0;	//   ,    _putchar
volatile int USART_TxTail=0;	//   ,     SIGNAL(USART0_UDRE_vect)

//UART 
#define USART_RX_BUFFER_SIZE 32	 //2,4,8,16,32,64,128 or 256 bytes
#define USART_RX_BUFFER_MASK (USART_RX_BUFFER_SIZE - 1)
char USART_RxBuf[USART_RX_BUFFER_SIZE];
volatile int USART_RxHead=0;	//   ,     SIGNAL(USART0_RX_vect)
volatile int USART_RxTail=0;	//     _getchar			  
//--------------------------------------------------------------------------------------------------------------------
int sendchar (int ch)  {									/* Write character to Serial Port */
int tmphead;
	tmphead = (USART_TxHead + 1) & USART_TX_BUFFER_MASK; 	//    
	while (tmphead == USART_TxTail);						//   
	USART_TxBuf[tmphead] = (char)ch;		   				//Store data in buffer
	USART_TxHead = tmphead;									//Store new index
	*US_IER = 1<<1;											//   .  -  _putchar
	return (ch);}											/* Transmit Character */
//--------------------------------------------------------------------------------------------------------------------
int fputc(int ch, FILE *f) {
	if (ch == '\n') {(sendchar('\r'));}
	return (sendchar(ch)); }
//--------------------------------------------------------------------------------------------------------------------
void _ttywrch(int ch) {
	if (ch == '\n') {(sendchar('\r'));}
	sendchar(ch);}
//--------------------------------------------------------------------------------------------------------------------
//      
int	getch(void)
{	USART_RxTail = (USART_RxTail + 1) & USART_RX_BUFFER_MASK;//    
	return USART_RxBuf[USART_RxTail];}		   	//Return data
//--------------------------------------------------------------------------------------------------------------------
//     getch()       buf[]
//   0xD  0xA,     buf[]     
//      .
char *read_line(char buf[])		//  4-20   48
{	static  int	 cnt = 0;		//  
	char c;						// 
	if(USART_RxHead == USART_RxTail)//   
	{return  (char *) 0;}		// 
	c = getch();				//   
	if(c == '\n' || c == '\r')	//  0xD  0xA:
	{  	buf[cnt] = 0;			//       
		cnt = 0;				// 
		return  buf;}			//   
	else						//   0xD  0xA:
	{	if(cnt < 80-1)			//80 -   CONFIG_CONSOLE_LINE_SIZE.       
		{buf[cnt++] = c;}		//    .
		return  (char *) 0;}
}//char *read_line(char buf[])
//--------------------------------------------------------------------------------------------------------------------
void parseCmd( char *cmd ) 			//cmd      
{	char *tok;						//    Char
	if( cmd == 0 ) {return;}		//   0, 
	tok = strtok (cmd, " ");		//tok      
	if( tok == NULL ) {return;}		//   - 
// Reset
	if(strncmp( tok, "RESET", sizeof("RESET")-1 ) == 0 )
	{printf( "Reseting...\n" );		// 
	while (1) {}}
	if(strncmp( tok, "BEEP", sizeof("BEEP")-1 ) == 0 )
	{Beep=2;
	printf( "Beep...\n" );}			// 
}//void parseCmd( char *cmd )
//--------------------------------------------------------------------------------------------------------------------
__irq void UART_RXTX_int (void) {  			//  USART0 .
volatile int RXTX;							//
	RXTX = *US_CSR;							//US_CSR     
	if (RXTX & 2) {							//   TXRDY = 1
		if (USART_TxHead != USART_TxTail)	//Check if all data is transmitted
			{USART_TxTail = (USART_TxTail + 1) & USART_TX_BUFFER_MASK;//    
			*US_THR = (int)USART_TxBuf[USART_TxTail];}//Start transmition
		else{*US_IDR = 1<<1;}}				//   .  -  _putchar
	if (RXTX & 1){							//    RXRDY = 1
	USART_RxHead = (USART_RxHead + 1) & USART_RX_BUFFER_MASK;	//    
	USART_RxBuf[USART_RxHead] = (char)*US_RHR;//Store received data in buffer
	}//if (RXTX & 1)
*AIC_EOICR = 1;}//__irq void UART_RXTX_int (void)
